import re
from satine import kernel
from satine import dt
from satine.grapes import grape
from types import StringType
import sys
import imp
from StringIO import StringIO
import traceback
import satine
import threading


def __resolve__(name):
    idx = name.rfind('.')
    modname = name[:idx]
    try:
        if idx != -1:
            module = sys.modules[name[:idx]]
            obj = name[idx+1:]
            if hasattr(module, obj):
                return getattr(module, obj)
            else:
                return None
    except KeyError:
        pass

    path = None 
    module = None
    pieces = name.split('.')
    for piece in pieces[:-2]:
        fp, path, description = imp.find_module(piece,path)
        try:
            package = imp.load_module(piece, fp, path, description)
            path = package.__path__
        except e:
            # Since we may exit via an exception, close fp explicitly.
            if fp:
                fp.close()
            raise e

    for piece in pieces[-2:-1]:
        fp, path, description = imp.find_module(piece,path)
        try:
            module = imp.load_module(modname, fp, path, description)
        except:
            # Since we may exit via an exception, close fp explicitly.
            if fp:
                fp.close()
            return None
    try:
       res = getattr(module, pieces[-1])
       print "Satine: resolved", res
       return res
    except:
        return None
                

class bind(satine.xlist):
    __attrs__ = """<xsd:string>on
                    <xsd:string>do
                    <xsd:string default="continue">then"""
    
class config(satine.xlist):
    pass

class BindActionIsNone(grape):
    def __init__(self, dispatcher, address, action):
        self.dispatcher = dispatcher
        self.address = address
        self.action = action

    def process(self, message, code, mimetype):
        message = """While matching address %s, grape %s generate exception.\n
                    Input message was:\n %s""" % (self.address, self.action, str(message))
        return message, code, mimetype           
                
class Dispatcher:
    def __init__(self, model):
        self.listeners = []
        self.queues = []
        self.config = config()
        self.config_file = None
        self.cache = {}
        self.model = model
       

    def load(self, config_file):
        """load the settings from a config file"""
        self.config_file = config_file
        file = open(config_file)
        data = file.read()
        self.config = kernel.xml2py(data)
        if self.config is None:
            print "Error loading config file:",config_file
            return
        error = self.config.validate()
        if error:
            print "Bad config file", config_file, error 
        
               
    def process(self, address, message, code, mimetype):
        if address == "/@reload":
            self.load(self.config_file)
            self.cache = {}
            return """<html><body>configuration file % reloaded</body>
                    </html>""" % (self.config_file,), 200, "text/html"
        
        if address in self.cache:
            handlers = self.cache[address]
        else:
            handlers = []
            for block in self.config.iter(".<satine:block>|"):
                for bind in block:
                    pass

            for block in self.config.iter(".<satine:block>|"):
                for bind in block:
                    if re.search(bind.on, address, re.IGNORECASE):
                        try:
                            obj = __resolve__(bind.do)
                            prs = [self, address, self.model]
                            for param in bind.iter(".<satine:parameter>|"):
                                prs.append(param[0])
                            hdl = apply(obj, prs)
                            handlers.append(hdl)
                        except:
                            print "Satine WS: exception while binding path and grapes"                                   
                            traceback.print_exc()
                            handlers.append(BindActionIsNone(self, address, bind.do))
                            
                        if bind.then == "break":
                            break
            self.cache[address] = handlers

        if len(handlers) == 0:
            return message, 404, mimetype
        try:
            for handler in handlers:
               message, code, mimetype = handler.process(message,code,mimetype)
        except:
            print "Satine WS: exception while processing message in grapes %s" % (str(handler),)
            traceback.print_exc()

        return message, code, mimetype             

def test():
    dispatcher = Dispatcher()
    dispatcher.load(open("config.xml"))
    print "test queues"
    qu = dispatcher.new_queue("/test")
    dispatcher.receive("/test/mondo", kernel.xml2py("<prova/>"))
    qu.blocking(1)
    print qu.read()


if __name__ == '__main__':
    test()

satine.xspace(satine="http://satine.sourceforge.net/schemas/kernel")