from satine.schemaclib import *


def usage():
    print """
usage: schemac [-options] -o output -p defalt_prefix -u target_uri schema

    where -options can be:
    --python: generate python code
    --html: generate html description

schema is the file that contains the schema
"""

def main():
    print "Satine schema compiler version 0.1\n\n"
    try:
        opts, args = getopt.getopt(sys.argv[1:], "o:p:u:", ["cpp","python","java","c#","html"])
    except getopt.GetoptError:
        # print help information and exit:
        usage()
        sys.exit(2)

    if not args:
        usage()
        sys.exit(2)

    if not len(opts):
        print "you must supply a target language\n"
        usage()
        sys.exit(2)
        
       
    try:
        filename = args[0]
        stream = open(filename)
    except:
        print "enable to read file "+filename
        sys.exit(2)

    document = stream.read()
    print "reading "+filename+"... OK"

    ofilename = None
    prefix = None
    uri = None
    for op, vl in opts:
        if op == "-o":
            ofilename = vl
        elif op == "-p":
            prefix = vl
        elif op == "-u":
            uri = vl

    if not prefix:
        print "default prefix is mandatory"
        usage
        sys.exit(2)
        
    for op, vl in opts:
        if op == "--python":
            print "generating python code\n"
            code = pythonc().compile(document,prefix, uri)
            if ofilename:
                ofilename = ofilename + ".py"
                ofile = open(ofilename, "w")
                ofile.write(code)
                ofile.close()
            else:
                ofilename = 'standard output'
                ofile = sys.stdout
                ofile.write(code)
            print "\n\npython code successfully generated and saved to "+ofilename+"\n"
            
        if op == "--java":
            print "Unsupported language"
        if op == "--c#":
            print "Unsupported language"
        if op == "--cpp":
            print "Unsupported language"
        if op == "--html":
            print "support soon\n"

                    

if __name__ == "__main__":
    main()
